/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUTPAP_TIPOAJPAGAR                                          */
/* Tabela : TIPOAJPAGAR                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATUTPAP_TIPOAJPAGAR' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATUTPAP_TIPOAJPAGAR
GO

CREATE TRIGGER DTULTATUTPAP_TIPOAJPAGAR
ON TIPOAJPAGAR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOAJPAGAR', null, 'CDAJUCTPAG=' + CDAJUCTPAG + ';',                               GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TIPOAJPAGAR
      SET DTULTATUTPAP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOAJPAGAR.CDAJUCTPAG,0  ) = ISNULL(INSERTED.CDAJUCTPAG,0  )) AND                                                  (ISNULL(TIPOAJPAGAR.CDHISTPADR,0  ) = ISNULL(INSERTED.CDHISTPADR,0  )) AND
            (ISNULL(TIPOAJPAGAR.CDCONTCTBL,0  ) = ISNULL(INSERTED.CDCONTCTBL,0  )) AND
            (ISNULL(TIPOAJPAGAR.DSAJUCTPAG,0  ) = ISNULL(INSERTED.DSAJUCTPAG,0  )) AND
            (ISNULL(TIPOAJPAGAR.IDAJUCTPAG,0  ) = ISNULL(INSERTED.IDAJUCTPAG,0  ));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATUTPAP_TIPOAJPAGAR','4.11.072';
GO

