<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeAlteescala extends \Doctrine\ORM\EntityRepository {
    
    
    public function obterEscalaEntrePeriodo($iniperiodo, $fimperiodo, $competencia, $nrVinculo, $nrorg){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'       => $nrorg, 
            'P_NRVINCULOM'  => $nrVinculo,
            'P_COMPETENCIA' => $competencia,
            'P_INIPERIODO'  => $iniperiodo->format('d/m/Y'),
            'P_FIMPERIODO'  => $fimperiodo->format('d/m/Y'),
        );

$sql = <<<SQL
    SELECT 
        * 
    FROM GPE_ALTEESCALA E
    WHERE
        E.NRVINCULOM = :P_NRVINCULOM 
        AND E.NRORG = :P_NRORG 
        AND :P_INIPERIODO BETWEEN E.DTINIESCALA AND NVL(E.DTFIMESCALA, :P_FIMPERIODO) 
        AND E.DTINIESCALA = (
            SELECT
                MAX(DTINIESCALA) DTINIESCALA 
            FROM
                GPE_ALTEESCALA MAX_ALTEESCALA 
            WHERE
                MAX_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_COMPETENCIA) 
                AND MAX_ALTEESCALA.NRORG = E.NRORG 
                AND MAX_ALTEESCALA.NRVINCULOM = E.NRVINCULOM
        )      
SQL;

        $result = $db->fetchAll($sql,$params);

        return $result;
    }
    
    public function getAlteEscalaByCompetencia($nrvinculom, $nrorg, $dtmescompetenc) {
        
        $params = array(
            'P_NRORG'       => $nrorg, 
            'P_NRVINCULOM'  => $nrvinculom,
            'P_COMPETENCIA' => $dtmescompetenc,
        );

$sql = <<<SQL
    SELECT *
    FROM GPE_ALTEESCALA AE
    WHERE AE.NRORG = :P_NRORG AND AE.NRVINCULOM = :P_NRVINCULOM AND AE.DTINIESCALA = (
        SELECT
            MAX(DTINIESCALA)
        FROM
            GPE_ALTEESCALA 
        WHERE
            DTINIESCALA <= LAST_DAY(:P_COMPETENCIA) 
            AND NRORG = AE.NRORG 
            AND NRVINCULOM = AE.NRVINCULOM
    )
SQL;

        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAssoc($sql,$params);

        return $result;
    }
    
}

    